function success = Winds_Bulk_CQI(exp,inpd,qitype,qival)
% old data colums - see email to Dave Stettner
% doublecheck.... test with new data, sent away!

indir=sprintf('%s',inpd)
outflnm=sprintf('Exp_2%i_BulkCQIstatsout.txt',exp);
% For 2018 Dataset, due to crossing of International Date line need to
% relabel x-axis
%xlb=zeros(3,1);
%xlb(1,1)=140;
%xlb(2,1)=180;
%xlb(3,1)=-140;

fal1= {'EUM',  'BRZ', 'JMA', 'NOA' , 'KMA', 'NWC'};


% new data columns
% 1. IDN     
% 2. LAT[DEG]     
% 3. LONG[DEG]     
% 4. TBOX[PIX]     
% 5. SBOX[PIX]     
% 6. SPD[MPS]     
% 7. DIR[DEG]     
% 8. P[HPA]     
% 9. LOWL     
% 10.MSPD[MPS]     
% 11.MDIR[DEG]     
% 12.ALB[%]     
% 13.CORR[%]     
% 14.TMET     
% 15.PERR[HPA]     
% 16.HMET     
% 17.CQI[%]     
% 18.QIF[%]

%clear;

% Set exp: 2,3,4
%exp=4

%qitype=17  % QI with forecast (18) or without (17)

%if (exp == 2 )
if (exp == 1 ) 
    %fall= {'BrazilDatasetTwo.csv',  'EUMETSATDatasetTwo.csv', 'JapanDatasetTwoNew.csv', 'KoreaDatasetTwo.csv', 'NOAADatasetTwo.csv', 'NWCSAFDatasetTwo_O_ET_E.csv',};
    fall= {'EUM321_csv.csv',  'BRZCPTECfin_121_csv.csv', 'JMA421_csv.csv', 'NOA621_csv.csv' , 'KMA521NI_csv.csv', 'NWC721_csv.csv'};
    fsym= {'b.'                 , 'g^'                     , 'y'                     , 'k+'                 , 'ro'                , 'ms'};
    %tbsize=[32 24 24 24 19 24];
     tbsize=[16 16 16 17 16 16];
     
end

%if (exp == 3 )
if (exp == 2 )
   %fall= {'BrazilDatasetThree.csv', 'EUMETSATDatasetThree.csv', 'JapanDatasetThreeNew.csv', 'KoreaDatasetThree.csv', 'NOAADatasetThree.csv', 'NWCSAFDatasetThree_P_ET_E.csv',};
   %fall= {'EUM322_csv.csv',  'BRZCPTECfin_122_csv.csv', 'JMA422_csv.csv', 'NOA622_csv.csv' , 'KMA522NI_csv.csv', 'NWC722_csv.csv'};
   fall= {'EUM322_csv.csv',  'BRZCPTECfin_122_csv.csv', 'JMA423_csv.csv', 'NOA622_csv.csv' , 'KMA522NI_csv.csv', 'NWC723_csv.csv'};
   fsym= {'b.'                 , 'g^'                     , 'y'                     , 'k+'                 , 'ro'                , 'ms'};
   %tbsize=[24 24 24 24 24 24];
   tbsize=[22 24 7 19 16 24];
end

%if (exp == 4 )
if ( exp == 3 ) 
    %fall= {'BrazilDatasetFour.csv', 'EUMETSATDatasetFour.csv', 'JapanDatasetFourNew.csv', 'KoreaDatasetFour.csv', 'NOAADatasetFour.csv', 'NWCSAFDatasetFour_O_C_E.csv',};
    %fall = {'EUM352_csv.csv',  'BRZCPTECfin_152_csv.csv', 'JMA452_csv.csv', 'NOA652_csv.csv' , 'KMA552NI_csv.csv', 'NWC752_csv.csv'};
    fall = {'EUM352_csv.csv',  'BRZCPTECfin_152_csv.csv', 'JMA453_csv.csv', 'NOA652_csv.csv' , 'KMA552NI_csv.csv', 'NWC753_csv.csv'};
    fsym= {'b.'                 , 'g^'                     , 'y'                     , 'k+'                 , 'ro'                , 'ms'};
    %tbsize=[24 24 24 24 24 24];
     tbsize=[22 24 7 19 16 24];
end

%    figure;
fid=fopen(outflnm,'w');
for i=1:6
    fname=fall{i};
    fnameo=fal1{i};
    %a=load(fname);
    a=dlmread([indir,fall{i}],';',1,0);
    
    %Remove records with invalid pressure
    abad=find(a(:,8)==0);
    a(abad,:)=[];

    %Remove records with invalid latitude
    abad=find(a(:,2) >  90);
    a(abad,:)=[];
    abad=find(a(:,2) < -90);
    a(abad,:)=[];
    
    %For 2018 we are dealing with International date line and Mcidas notation.
    %Therefore need to convert negative lons into positive values
    aposlon=find(a(:,3) < 0);
    a(aposlon,3)=((a(aposlon,3)+180)+180);
   
    

    spd25=find(a(:,6)>=2.5);
    a=a(spd25,:);
    
    % Scale JMA QI 0 to 100 for 2014 Dataset

    %if ( i == 3)
    %    a(:,qitype)=a(:,qitype)*100.;
    %end

    good_50=find(a(:,qitype)>=50);
    good_80=find(a(:,qitype)>=80);
    good_qi=find(a(:,qitype)>=qival);
    figure;
    set(gcf, 'visible', 'off')
    subplot(2,3,1);
    hold on;
    %plot(a(:,3),a(:,2),'r.');
    scatter(a(:,3),a(:,2),2,'r.');
    scatter(a(good_50,3),a(good_50,2),2,'b.');
    scatter(a(good_80,3),a(good_80,2),2,'g.');
    names={'All AMV','QI>=50','QI>=80'};
    label(1)=names(1);
    label(2)=names(2);
    label(3)=names(3);
    legend(gca,label(:),'FontSize',4,'FontWeight','bold','Location','Northwest');
    %legend('All AMV', 'QI>=50','QI>=80','Location','northwest','Orientation','horizontal');
    xlabel('Lon');
    ylabel('Lat');
    title(fnameo);
%     plot(a(good_80,3),a(good_80,2),fsym{i});
     %xlim([-50  50])
     xlim([160 280])
     set(gca,'xdir','reverse')
     ylim([-50  50])
     
     %For 2018 Dataset need to relabel x-axis from 140 to -60
     set(gca,'XTick',[ 160 200 240 280 ])
     set(gca,'XTickLabel',[-160 160 120 80])
%     hold on;

    disp('**************************');
    %disp(fname);
    
    fprintf(fid,'For File: %s \n',fname);
    fprintf(fid,'Target box size in pixels: %d \n',tbsize(i));
    fprintf(fid,'Total num winds: %d \n',length(a(:,1)));
    fprintf(fid,'Winds QI>=%d: %d \n',qival,length(good_qi));

    fprintf(fid,'Lat_min, %6.2f \n', min(a(:,2)));
    fprintf(fid,'Lat_max, %6.2f \n', max(a(:,2)));
    fprintf(fid,'Lon_west, %6.2f \n', min(a(:,3)));
    fprintf(fid,'Lon_east, %6.2f \n', (360-max(a(:,3))));

    fprintf(fid,' \n');
    fprintf(fid,'*** For AMV with QI>=%d ***\n', qival);    
   
    alow=find(a(good_qi,8)>=700);
    amid=find(a(good_qi,8)<700 & a(good_qi,8)>400);
    ahigh=find(a(good_qi,8)<=400);
      
    fprintf(fid,'SPD_min, %6.2f \n', min(a(good_qi,6)));
    fprintf(fid,'SPD_max, %6.2f \n', max(a(good_qi,6)));
    fprintf(fid,'SPD_mean, %6.2f \n', mean(a(good_qi,6)));   
    
    fprintf(fid,'P_min, %6.2f \n', min(a(good_qi,8)));
    fprintf(fid,'P_max, %6.2f \n', max(a(good_qi,8)));
    fprintf(fid,'P_mean, %6.2f \n', mean(a(good_qi,8)));
    
    fprintf(fid,'Low_winds, %6.2f \n', 100*length(alow)/length(good_qi) );
    fprintf(fid,'Mid_winds, %6.2f \n', 100*length(amid)/length(good_qi) );
    fprintf(fid,'High_winds, %6.2f \n', 100*length(ahigh)/length(good_qi) );  
    
    aa=a(good_qi,:);
    fprintf(fid,'Low_SPD_min, %6.2f \n', min(aa(alow,6)));
    fprintf(fid,'Low_SPD_max, %6.2f \n', max(aa(alow,6)));
    fprintf(fid,'Low_SPD_mean, %6.2f \n', mean(aa(alow,6)));  
       
    fprintf(fid,'Low_P_min, %6.2f \n', min(aa(alow,8)));
    fprintf(fid,'Low_P_max, %6.2f \n', max(aa(alow,8)));
    fprintf(fid,'Low_P_mean, %6.2f \n', mean(aa(alow,8)));
    
    fprintf(fid,'Mid_SPD_min, %6.2f \n', min(aa(amid,6)));
    fprintf(fid,'Mid_SPD_max, %6.2f \n', max(aa(amid,6)));
    fprintf(fid,'Mid_SPD_mean, %6.2f \n', mean(aa(amid,6)));    
    
    fprintf(fid,'Mid_P_min, %6.2f \n', min(aa(amid,8)));
    fprintf(fid,'Mid_P_max, %6.2f \n', max(aa(amid,8)));
    fprintf(fid,'Mid_P_mean, %6.2f \n', mean(aa(amid,8)));

    fprintf(fid,'High_SPD_min, %6.2f \n', min(aa(ahigh,6)));
    fprintf(fid,'High_SPD_max, %6.2f \n', max(aa(ahigh,6)));
    fprintf(fid,'High_SPD_mean, %6.2f \n', mean(aa(ahigh,6)));    
    
    fprintf(fid,'High_P_min, %6.2f \n', min(aa(ahigh,8)));
    fprintf(fid,'High_P_max, %6.2f \n', max(aa(ahigh,8)));
    fprintf(fid,'High_P_mean, %6.2f \n', mean(aa(ahigh,8)));

    subplot(2,3,2);
    hist(a(good_qi,qitype),11); % QI
    v=axis;
    axis([qival 100 v(3) v(4)]);
    title(['QI' ' ' fnameo]);

    subplot(2,3,3);
    hist(a(good_qi,6),11); % SPD
    v=axis;
    axis([0 100 v(3) v(4)]);
    title(['SPD' ' ' fnameo]);

    subplot(2,3,4);
    hist(a(good_qi,7),45); % DIR
    v=axis;
    axis([0 360 v(3) v(4)]);
    title(['DIR' ' ' fnameo]);
    
    subplot(2,3,5);
    hist(a(good_qi,8),21); % H
    v=axis;
    axis([100 1000 v(3) v(4)]);
    title(['P' ' ' fnameo]);
    
    if ( exp == 1)
        saveas(gcf, ['Exp_21_CQI_' fname(1:6)], 'tif');
    end
    
    if ( exp == 2)
        saveas(gcf, ['Exp_22_CQI_' fname(1:6)], 'tif');
    end
    
    if ( exp == 3)
        saveas(gcf, ['Exp_52_CQI_' fname(1:6)], 'tif');
    end
    
% THIS section doesn't make sense with the new data sets, as they don't have Height Assignment Method. Best to be deleted.        
% %     subplot(2,3,6);
% %     aa=a(good_50,:);
% %     if i==1
% %         ind_0=find( a(good_50,26)==1 );
% %         aa(ind_0,26)=0;
% %         ind_1=find( a(good_50,26)==14 );
% %         aa(ind_1,26)=1;
% %         ind_2=find( a(good_50,26)==2 |  a(good_50,26)==3 |  a(good_50,26)==4 |  a(good_50,26)==5 );
% %         aa(ind_2,26)=2;        
% %     end;
% %     hist(aa(:,26),0:3); % HAM
% %     title(['HAM' ' ' fname]);
  
      %saveas(gcf,['bulk_' fname(1:3) '.tif'],'tif');    
    
%     figure;
%     hist(a(good_50,2)); % Lat (zonal distribution)
%     title(['Lat' ' ' fname]);
%     saveas(gcf,['hist_lat_' fname(1:3) '.tif'],'tif');    
%     
%     figure;
%     hist(a(good_50,3)); % Lon
%     title(['Lon' ' ' fname]);
%     saveas(gcf,['hist_lon_' fname(1:3) '.tif'],'tif');    
%    
    
%     pause;
%     keyboard;
    
end;
    
fclose(fid);
close(figure(1:6))
 success='yes'; 
